/*!
    @header BTCGELayer.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 01/22/2007
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <Foundation/NSObject.h>
#import <SMKCGExtensions/CGELayer.h>
#import <SMKBitmapTools/BTImage.h>

/*!
    @class BTCGELayer
    @discussion "-prepareXEditing" & "-finalizeXEditing" are the same as "-beginXEditing" & "-endXEditing" except they don't save/restore context's state (if any). "-beginXEditing" & "-endXEditing" are implemented using corresponding "-prepareXEditing" / "-finalizeXEditing".
*/
@interface BTCGELayer : NSObject<BTCGImage, BTCocoaImage, BTCGMutableImage, BTCocoaMutableImage>
{
@private
    CGELayerRef _layer;
    NSGraphicsContext* _layerGraphicsContext;
}

+ (id)layerWithCGELayer:(CGELayerRef)layer;

- (id)initWithCGELayer:(CGELayerRef)layer; // Designated initializer.

- (CGELayerRef)CGELayer;

- (void)prepareCGEditing;
- (void)finalizeCGEditing;

- (void)prepareCocoaEditing;
- (void)finalizeCocoaEditing;

@end
