/*!
    @header BTCGRawMutableImage.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/02/09
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <SMKBitmapTools/BTCGMutableImage.h>

/*!
    @class BTCGRawMutableImage
    @abstract Generic representation of a raw Core Graphics image & attached context.
*/
@interface BTCGRawMutableImage : BTCGMutableImage<BTRawImage, BTRawMutableImage>
{
@private
    void* _mutableImageBytes;
    BTImageFormat _imageFormat;
    CMProfileRef _imageColorProfile;
}

// `imageColorProfile' may be nil.
- (id)initWithCGImage:(CGImageRef)image context:(CGContextRef)imageContext mutableBytes:(void*)mutableImageBytes format:(BTImageFormat)imageFormat colorProfile:(CMProfileRef)imageColorProfile; // Designated initializer.

@end
