/*!
    @header BTCreateFreeHandSelectionTool.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/02/09
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <SMKBitmapTools/BTTool.h>
#import <SMKBitmapTools/NSViewBTMouseTracking.h>
#import <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGGeometry.h>
#import <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGPath.h>

/*!
    @class BTCreateFreeHandSelectionTool
    @discussion Stage cycle: BTWaitingToolStage -> BTCreatingSelectionToolStage.
*/
@interface BTCreateFreeHandSelectionTool : BTTool<BTMouseTracker>
{
@private
    NSCursor* _willCreateSelectionCursor;
    NSCursor* _doCreateSelectionCursor;
    NSPoint _selectionStartPoint;
    CGPathRef _selectionPath;
    CGMutablePathRef _workSelectionPath;
    CGRect _selectionPathBounds;
    
    BOOL _isTracking : 1;
    BOOL _isCreatingSelectionPath : 1;
    BOOL _areSelectionPathBoundsCalculated : 1;
}

- (NSCursor*)defaultWillCreateSelectionCursor;
- (NSCursor*)willCreateSelectionCursor;
- (void)setWillCreateSelectionCursor:(NSCursor*)willCreateSelectionCursor;

- (NSCursor*)defaultDoCreateSelectionCursor;
- (NSCursor*)doCreateSelectionCursor;
- (void)setDoCreateSelectionCursor:(NSCursor*)doCreateSelectionCursor;

- (NSValue* /* with NSPoint */)selectionStartPoint;
- (id /* CGPathRef */)selectionPath;

- (IBAction)selectAllArea:(id)sender;

@end

#pragma mark *** Stages ***

/*!
    @const BTCreatingSelectionToolStage
    @abstract Tool is creating selection.
    @discussion Deactivation type: abortive.
*/
#ifndef BTCreatingSelectionToolStage
    #define BTCreatingSelectionToolStage @"BTCreatingSelectionToolStage"
#endif
