/*!
    @header BTCreateMagicWandSelectionTool.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/03/01
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <SMKBitmapTools/BTTool.h>
#import <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGPath.h>
#import <SMKCGExtensions/CGEFloat.h>

/*!
    @class BTCreateMagicWandSelectionTool
    @discussion Stage cycle: BTWaitingToolStage.
*/
@interface BTCreateMagicWandSelectionTool : BTTool
{
@private
    NSCursor* _willCreateSelectionCursor;
    CGFloat _tolerance;
    NSPoint _selectionStartPoint;
    CGPathRef _selectionPath;
}

- (NSCursor*)defaultWillCreateSelectionCursor;
- (NSCursor*)willCreateSelectionCursor;
- (void)setWillCreateSelectionCursor:(NSCursor*)willCreateSelectionCursor;

- (CGFloat)tolerance;
- (void)setTolerance:(CGFloat)tolerance;

- (NSValue* /* with NSPoint */)selectionStartPoint;
- (id /* CGPathRef */)selectionPath;

- (IBAction)selectAllArea:(id)sender;

@end
