/*!
    @header BTDataArray.h
    @project SMKBitmapTools
    @author Oleg Yaros
    @creation_date 2007/06/08
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <Foundation/NSObject.h>
#import <Foundation/NSRange.h>
#import <SMKBitmapTools/BTNSObjCRuntime.h>

@class NSData;


@interface BTDataArray : NSObject <NSCopying, NSMutableCopying>

- (NSUInteger)count;
- (NSUInteger)itemSize;
- (const void*)bytesOfItemAtIndex:(NSUInteger)index;    // exceptions: NSRangeException

@end

@interface BTDataArray(BTExtendedDataArray)

- (NSData*)allItemsData;
- (NSData*)itemsDataInRange:(NSRange)range;

- (const void*)bytesOfLastItem;

@end

@interface BTDataArray(BTDataArrayCreation)

+ (id)arrayWithData:(NSData*)data itemSize:(NSUInteger)itemSize count:(NSUInteger)count;
- (id)initWithData:(NSData*)data itemSize:(NSUInteger)itemSize count:(NSUInteger)count;

@end


@interface BTMutableDataArray : BTDataArray

- (void)setCount:(NSUInteger)count;
- (void*)mutableBytesOfItemAtIndex:(NSUInteger)index;   // exceptions: NSRangeException

@end

@interface BTMutableDataArray(BTMutableDataArrayCreation)

+ (id)arrayWithCount:(NSUInteger)count itemSize:(NSUInteger)itemSize;
- (id)initWithCount:(NSUInteger)count itemSize:(NSUInteger)itemSize;

@end

@interface BTMutableDataArray(BTMutableDataEditing)

- (void)addItemBytes:(const void*)bytes;

@end

/***************** exceptions *****************/
extern NSString* const BTDataArrayInvalidInitializer;
