/*!
    @header BTFillTool.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/02/08
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <SMKBitmapTools/BTTool.h>
#import <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGColor.h>
#import <SMKCGExtensions/CGEFloat.h>
#import <SMKCGExtensions/CGEColor.h>

/*!
    @class BTFillTool
    @discussion Stage cycle: BTWaitingToolStage.
*/
@interface BTFillTool : BTTool
{
@private
    NSCursor* _willDrawCursor;
    CGEColorRef _fillColor;
    CGEColorRef _alternateFillColor;
    CGFloat _tolerance;
    
    BOOL _isFillColorInitialized : 1;
}

- (NSCursor*)defaultWillDrawCursor;
- (NSCursor*)willDrawCursor;
- (void)setWillDrawCursor:(NSCursor*)willDrawCursor;

- (id /* BTPointer* with CGEColorRef */)defaultFillColor;
- (id /* BTPointer* with CGEColorRef */)fillColor;
- (void)setFillColor:(id /* CGColorRef or BTPointer* with CGEColorRef */)fillColor;

- (id /* BTPointer* with CGEColorRef */)alternateFillColor;
- (void)setAlternateFillColor:(id /* CGColorRef or BTPointer* with CGEColorRef */)alternateFillColor;

- (CGFloat)tolerance;
- (void)setTolerance:(CGFloat)tolerance;

@end
