/*!
    @header BTMutableCGImageUndoer.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2008/05/13
    @copyright Copyright (c) 2008 The Software MacKiev Company. All rights reserved.
*/

#import <Foundation/NSObject.h>
#import <SMKBitmapTools/BTImage.h>
#import <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGGeometry.h>

@interface BTMutableCGImageUndoer : NSObject<BTImageUndoing>
{
@private
    id<BTCGImage, BTCGMutableImage> _image;
    id<BTImageUndoingDelegate> _delegate;
    
    id<BTCGImage> _originalImageCopy;
    CGRect _changedRect;
    
    BOOL _isGrouping : 1;
}

- (id)initWithImage:(id<BTCGImage, BTCGMutableImage>)image delegate:(id<BTImageUndoingDelegate>)delegate; // Designated initializer.

- (id<BTCGImage, BTCGMutableImage>)image;

@end
