/*!
    @header BTUndoProxy.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/11/22
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <Foundation/NSObject.h>

@class NSInvocation, NSUndoManager;

/*!
    @class BTUndoProxy
    @discussion Undo proxies may be used to break undo actions into categories thus allowing to remove whole category from undo manager with -[NSUndoManager removeAllActionsWithTarget:undoProxy].
*/
@interface BTUndoProxy : NSObject
{
@private
    NSUndoManager* _undoManager;
    id _undoTarget;
}

// Use these to register actions through receiver thus adding them into receiver's action category.
- (void)registerUndoInManager:(NSUndoManager*)undoManager withTarget:(id)target selector:(SEL)selector object:(id)object;
- (id)prepareUndoInManager:(NSUndoManager*)undoManager withInvocationTarget:(id)target;

@end
