/*!
    @header BTWeakObjectProxy.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 12/16/2006
    @copyright Copyright (c) 2006 The Software MacKiev Company. All rights reserved.
*/

#import <Foundation/NSProxy.h>
#import <SMKBitmapTools/BTNSObjCRuntime.h>

/*!
    @class BTWeakObjectProxy
*/
@interface BTWeakObjectProxy : NSProxy
{
@private
    id _object;
}

- (id)init;

// Does not retain `object'. `object' may be nil.
- (id)initWithObject:(id)object; // Designated initializer.

- (id)object;
- (void)setObject:(id)object; // `object' may be nil.

@end
