/*!
    @header NSEventBTKeyBinding.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2007/04/04
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#import <AppKit/NSEvent.h>

@class NSString, NSArray, NSDictionary;

/*!
    @category NSEvent(BTKeyBinding)
*/
@interface NSEvent(BTKeyBinding)

+ (id)BT_interpretationForKeyEvents:(NSArray*)eventArray usingKeyBindingDictionary:(NSDictionary*)keyBindingDictionary;
+ (SEL)BT_commandSelectorForKeyEvents:(NSArray*)eventArray usingKeyBindingDictionary:(NSDictionary*)keyBindingDictionary;
+ (void)BT_interpretKeyEvents:(NSArray*)keyEvents asCommand:(SEL*)commandSelectorPtr text:(id*)insertStringPtr; // Interprets using Cocoas text input management system.

// `keyBindingDictionaryToMergIn', `baseKeyBindingDictionary' and result may be nil.
+ (NSDictionary*)BT_mergeKeyBindingDictionary:(NSDictionary*)keyBindingDictionaryToMergIn intoDictionary:(NSDictionary*)baseKeyBindingDictionary;

- (NSString*)BT_keyBindingCharacters;

- (id)BT_interpretationUsingKeyBindingDictionary:(NSDictionary*)keyBindingDictionary;
- (SEL)BT_commandSelectorUsingKeyBindingDictionary:(NSDictionary*)keyBindingDictionary;
- (void)BT_interpretAsCommand:(SEL*)commandSelectorPtr text:(id*)insertStringPtr; // Interprets using Cocoas text input management system.

@end
