/*!
    @header NSEventBTKeyboardModifierFlags.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 12/20/2006
    @copyright Copyright (c) 2006 The Software MacKiev Company. All rights reserved.
*/

#import <AppKit/NSEvent.h>
#import <SMKBitmapTools/BTNSObjCRuntime.h>

/*!
    @category NSEvent(BTKeyboardModifierFlags)
*/
@interface NSEvent(BTKeyboardModifierFlags)

/*!
    @method BT_modifierFlagsTypesMask
    @abstract Returns mask for event types which have valid modifier flags.
*/
+ (NSUInteger)BT_modifierFlagsTypesMask;

/*!
    @method BT_modifierFlags
    @abstract Returns the current hardware keyboard modifier state.
    @discussion Supported bits: NSAlphaShiftKeyMask, NSShiftKeyMask, NSControlKeyMask, NSAlternateKeyMask, NSCommandKeyMask, NSNumericPadKeyMask.
*/
+ (NSUInteger)BT_modifierFlags;

/*!
    @method BT_hasModifierFlags
    @abstract Returns whether modifier flags are valid for the receiver.
*/
- (BOOL)BT_hasModifierFlags;

@end
