/*!
    @header NSEventBTLocation.h
    @project SMKBitmapTools
    @author Alexey Navrotsky
    @creation_date 2008/02/20
    @copyright Copyright (c) 2008 The Software MacKiev Company. All rights reserved.
*/

#import <AppKit/NSEvent.h>
#import <SMKBitmapTools/BTNSObjCRuntime.h>

/*!
    @category NSEvent(BTLocation)
*/
@interface NSEvent(BTLocation)

/*!
    @method BT_locationTypesMask
    @abstract Returns mask for event types which have valid location.
*/
+ (NSUInteger)BT_locationTypesMask;

/*!
    @method BT_hasLocation
    @abstract Returns whether location is valid for the receiver.
*/
- (BOOL)BT_hasLocation;

@end
