/*!
    @header CGEDataConsumer.h
    @project SMKCGExtensions
    @author Alexey Navrotsky
    @creation_date 01/13/2007
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#ifndef CGEDataConsumer_H_
#define CGEDataConsumer_H_

#include <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGDataConsumer.h>
#include <CoreFoundation/CFBase.h>
#include <CoreFoundation/CFData.h>
#include <CoreFoundation/CFURL.h>

CG_EXTERN_C_BEGIN

#if MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4
    #define CGEDataConsumerCreateWithCFData CGDataConsumerCreateWithCFData
#else
    #define CGEDataConsumerCreateWithCFData __CGEDataConsumerCreateWithCFData
    
    CG_EXTERN CGDataConsumerRef CGEDataConsumerCreateWithCFData(CFMutableDataRef data);
#endif // MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4

// New data replaces existing data starting at offset `offset'. Length of `data' is increased or truncated as needed.
CG_EXTERN CGDataConsumerRef CGEDataConsumerCreateWithCFDataAndOffset(CFMutableDataRef data, size_t offset);

// Creates URL for temporary file to represent object at address `objectAddress' of type with name `objectTypeName'.
// `temporaryDirectoryPath' is in POSIX path style (kCFURLPOSIXPathStyle).
// Note: does not create file itself - only URL.
CG_EXTERN CFURLRef CGEDataConsumerCreateTemporaryFileURLForObject(CFStringRef temporaryDirectoryPath, CFStringRef fileUTI, CFStringRef objectTypeName, const void* objectAddress);

CG_EXTERN_C_END

#endif // CGEDataConsumer_H_
