/*!
    @header CGEDataProvider.h
    @project SMKCGExtensions
    @author Alexey Navrotsky
    @creation_date 01/13/2007
    @copyright Copyright (c) 2007 The Software MacKiev Company. All rights reserved.
*/

#ifndef CGEDataProvider_H_
#define CGEDataProvider_H_

#include <ApplicationServices/../Frameworks/CoreGraphics.framework/Headers/CGDataProvider.h>
#include <CoreFoundation/CFBase.h>
#include <CoreFoundation/CFData.h>

CG_EXTERN_C_BEGIN

// `bytes' will be deallocated using `free()'.
CG_EXTERN CGDataProviderRef CGEDataProviderCreateWithBytes(const void* bytes, size_t length);

// `bytes' will be deallocated using `deallocator'.
CG_EXTERN CGDataProviderRef CGEDataProviderCreateWithCFBytes(const void* bytes, size_t length, CFAllocatorRef deallocator);

#if MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4
    #define CGEDataProviderCreateWithCFData CGDataProviderCreateWithCFData
#else
    #define CGEDataProviderCreateWithCFData __CGEDataProviderCreateWithCFData
    
    CG_EXTERN CGDataProviderRef CGEDataProviderCreateWithCFData(CFDataRef data);
#endif // MAC_OS_X_VERSION_MIN_REQUIRED >= MAC_OS_X_VERSION_10_4

CG_EXTERN_C_END

#endif // CGEDataProvider_H_
