/*
 *  SMKCheckForUpdates.h
 *  SMKCheckForUpdates
 *
 *  Created by Yury Katkov on Wed Jun 02 2004.
 *  Copyright (c) 2004 The Software MacKiev Company. All rights reserved.
 */
/*!
    @header 	SMKCheckForUpdates.h
    @abstract   This file provides interface for SMKCheckForUpdates
    @discussion In Application you must register on kCFUCheckForUpdatesCompletedNotificationName and kCFUCheckForUpdatesFailedNotificationName notifications. Example:
	::CFNotificationCenterAddObserver(::CFNotificationCenterGetDistributedCenter(),
			<Your Observer>, <Notification Callback>, kCFUCheckForUpdatesCompletedNotificationName, <unicIdentifier>,
			CFNotificationSuspensionBehaviorCoalesce);
			
	::CFNotificationCenterAddObserver(::CFNotificationCenterGetDistributedCenter(),
			<Your Observer>, <Notification Callback 2>, kCFUCheckForUpdatesFailedNotificationName, <unicIdentifier>,
			CFNotificationSuspensionBehaviorCoalesce);

	If you get kCFUCheckForUpdatesCompletedNotificationName - <CFDictionaryRef userInfo> will have download dictionary

*/

#ifndef __SMKCheckForUpdates_SMKCheckForUpdates_h__
#define __SMKCheckForUpdates_SMKCheckForUpdates_h__

#ifdef __cplusplus
extern "C" {
#endif

void CFUCheckForUpdates(CFStringRef downloadUrl, CFStringRef unicIdentifier);
void CFUTerminateCheckForUpdates();

#ifdef __cplusplus
}
#endif

#endif __SMKCheckForUpdates_SMKCheckForUpdates_h__

