/*!
    @header SMKSubmitInfoTypes.h
    @project SMKSubmitInfo
    @author Oleg Yaros
    @creation_date 10/31/07
    @copyright Copyright 2007 The Software MacKiev Company. All rights reserved.
    @abstract Framework defines declaration.
*/

#if !defined(SMKSUBMITINFOTYPES_H)
#   define SMKSUBMITINFOTYPES_H

#   if defined(__cplusplus)
#       define SI_EXTERN_C_BEGIN     extern "C" {
#       define SI_EXTERN_C_END       }
#   else
#       define SI_EXTERN_C_BEGIN
#       define SI_EXTERN_C_END
#   endif // defined(__cplusplus)

/*!
    @enum       SIStatus
    @abstract   Submit operation status code.
    @constant   SIStatusOK operation finished successfully
    @constant   SIStatusGeneralError generic error identifier
    @constant   SIStatusQueueOverflow requests queue overflowed
*/
enum
{
    SIStatusOK = 0,
    SIStatusGeneralError = -1,
    SIStatusQueueOverflow = -2,
    SIStatusWrongFileFormat = -3,
    SIStatusSubmitDataTooBig = -4
};

typedef SInt32 SIStatus;

/*!
    @enum       SIOverflowFlags
    @abstract   Submit operation additional flags.
    @constant   SIOverflowReportError report error when requests queue is overflow
    @constant   SIOverflowRemoveRequestFromHead the first request from queue should be removed to free space for new one
    @constant   SIOverflowRemoveRequestFromTail the last request from queue should be removed to free space for new one
*/
enum
{
    SIOverflowReportError = 0,
    SIOverflowRemoveRequestFromHead = 1,
    SIOverflowRemoveRequestFromTail = 2
};

typedef CFOptionFlags SIOverflowFlags;

#endif // !defined(SMKSUBMITINFOTYPES_H)
